aboutsummaryrefslogtreecommitdiff
path: root/git-submodule.sh
diff options
context:
space:
mode:
authorJohan Herland <johan@herland.net>2009-06-03 08:27:06 +0200
committerJunio C Hamano <gitster@pobox.com>2009-06-03 00:04:52 -0700
commit329484256e0fe42676e93669122e7a5a007ef4ed (patch)
treeb745d01d1380f2bd9c8c7c88d5c0e59b5f8009e8 /git-submodule.sh
parentca2cedba70e9356a1a20b0e39acd07ab92fee80e (diff)
downloadgit-329484256e0fe42676e93669122e7a5a007ef4ed.tar.gz
git-329484256e0fe42676e93669122e7a5a007ef4ed.tar.xz
Rename submodule.<name>.rebase to submodule.<name>.update
The addition of "submodule.<name>.rebase" demonstrates the usefulness of alternatives to the default behaviour of "git submodule update". However, by naming the config variable "submodule.<name>.rebase", and making it a boolean choice, we are artificially constraining future git versions that may want to add _more_ alternatives than just "rebase". Therefore, while "submodule.<name>.rebase" is not yet in a stable git release, future-proof it, by changing it from submodule.<name>.rebase = true/false to submodule.<name>.update = rebase/checkout where "checkout" specifies the default behaviour of "git submodule update" (checking out the new commit to a detached HEAD), and "rebase" specifies the --rebase behaviour (where the current local branch in the submodule is rebase onto the new commit). Thus .update == checkout is equivalent to .rebase == false, and .update == rebase is equivalent to .rebase == true. Finally, leaving .update unset is equivalent to leaving .rebase unset. In future git versions, other alternatives to "git submodule update" behaviour can be included by adding them to the list of allowable values for the submodule.<name>.update variable. Signed-off-by: Johan Herland <johan@herland.net> Signed-off-by: Junio C Hamano <gitster@pobox.com>
Diffstat (limited to 'git-submodule.sh')
-rwxr-xr-xgit-submodule.sh32
1 files changed, 17 insertions, 15 deletions
diff --git a/git-submodule.sh b/git-submodule.sh
index 3176226ac..f384c6b2b 100755
--- a/git-submodule.sh
+++ b/git-submodule.sh
@@ -17,7 +17,7 @@ branch=
quiet=
cached=
nofetch=
-rebase=
+update=
#
# print stuff on stdout unless -q was specified
@@ -295,10 +295,10 @@ cmd_init()
git config submodule."$name".url "$url" ||
die "Failed to register url for submodule path '$path'"
- test true != "$(git config -f .gitmodules --bool \
- submodule."$name".rebase)" ||
- git config submodule."$name".rebase true ||
- die "Failed to register submodule path '$path' as rebasing"
+ upd="$(git config -f .gitmodules submodule."$name".update)"
+ test -z "$upd" ||
+ git config submodule."$name".update "$upd" ||
+ die "Failed to register update mode for submodule path '$path'"
say "Submodule '$name' ($url) registered for path '$path'"
done
@@ -329,7 +329,7 @@ cmd_update()
;;
-r|--rebase)
shift
- rebase=true
+ update="rebase"
;;
--)
shift
@@ -349,7 +349,7 @@ cmd_update()
do
name=$(module_name "$path") || exit
url=$(git config submodule."$name".url)
- rebase_module=$(git config --bool submodule."$name".rebase)
+ update_module=$(git config submodule."$name".update)
if test -z "$url"
then
# Only mention uninitialized submodules when its
@@ -370,9 +370,9 @@ cmd_update()
die "Unable to find current revision in submodule path '$path'"
fi
- if test true = "$rebase"
+ if ! test -z "$update"
then
- rebase_module=true
+ update_module=$update
fi
if test "$subsha1" != "$sha1"
@@ -390,16 +390,18 @@ cmd_update()
die "Unable to fetch in submodule path '$path'"
fi
- if test true = "$rebase_module"
- then
- command="git-rebase"
+ case "$update_module" in
+ rebase)
+ command="git rebase"
action="rebase"
msg="rebased onto"
- else
- command="git-checkout $force -q"
+ ;;
+ *)
+ command="git checkout $force -q"
action="checkout"
msg="checked out"
- fi
+ ;;
+ esac
(unset GIT_DIR; cd "$path" && $command "$sha1") ||
die "Unable to $action '$sha1' in submodule path '$path'"